require_relative 'exercise11game'
require_relative 'die'
require_relative 'exercise16'
require_relative 'exercise21'

module PAUL
class Player
    include Paul

    attr_accessor :name, :health
   
    def initialize(name, health=100)
        @name = name.capitalize
        @health = health
        @found_treasures = Hash.new(0)
    end

    def each_found_treasure
        @found_treasures.each do |name, points|
          yield Treasure.new(name, points)
        end
    end

    def found_treasure(treasure)
        @found_treasures[treasure.name] += treasure.points
        puts "#{@name} found a #{treasure.name} worth #{treasure.points} points."
        puts "#{@name}'s treasures: #{@found_treasures}"
    end

    def points
       @found_treasures.values.reduce(0, :+)
    end

    def to_s
        "I'm #{@name} with health of #{@health} and score of #{score}."
    end

end
end